let setting = [{
  name: 'style-bar',
  title: '柱体设置',
  options: {
    barWidth: 20,
    barSwitchBg: false,
    barBgColor: 'rgba(221, 221, 221,1)',
    barBorderRadius: 0
  }
}, {
  name: 'style-xlabel',
  title: 'X轴设置',
  options: {
    xAxisIsShow: true,
    xlabelFontSize: 12,
    xlabelColor: '#333333',
    xlabelSwitchAll: true,
    xlabelRotate: 0
  }
}, {
  name: 'style-ylabel',
  title: 'Y轴设置',
  options: {
    ylabelFontSize: 12,
    ylabelColor: '#333333'
  }
}, {
  name: 'style-serie',
  title: '系列设置',
  options: {
    colorList: []
  }
}, {
  name: 'style-bar-serie',
  title: '指标展示设置',
  options: {
    serieSet: []
  }
}, {
  name: 'style-code',
  title: '代码设置',
  options: {
    serieSet: []
  }
}, {
  name: 'style-legend',
  title: '图例设置',
  options: {
    legendShow: true,
    legendAlign: 'center',
    legendLeft: 0,
    legendRight: 0,
    legendTop: 0,
    orient: 'horizontal',
    legendType: 'scroll',
    legendTextStyle: {
      fontSize: 12,
      fontWeight: 'normal',
      fontColor: '#000',
    }
  }
}, {
  name: 'style-title',
  title: '标题设置',
  options: {
    isTitleShow: false, //是否标题
    titleText: '', //标题
    titleLeft: 0,
    titleRight: 0,
    titleTop: 0,
    titleAlign: 'left',
    textStyle: {
      fontSize: 14,
      fontWeight: 'normal',
      fontColor: '#000',
    }
  }
}, {
  name: 'style-grid',
  title: '图表属性',
  options: {
    gridLeft: 1, //
    gridRight: 1, //
    gridTop: 10, //
    gridBottom: 1, //
    containLabel: true, //标题位置
  }
}, {
  name: 'style-zuan',
  title: '下钻配置',
  options: {
    zuanFontColor: '#000000',
    zuanFenge: '>',
  }
}, {
  name: 'style-label',
  title: '数值配置',
  options: {
    labelSwitch: true,
    labelColor: '#333333',
    labelSize: 12,
    labelPosition: 'inside', // 数值位置
    labelBorderWidth: 0, // 描边粗细
    labelBorderColor: '#ffffff', // 描边颜色
    labelRotate: 0, // 旋转角度
    valueAnimation: true,
    labelThousandPoint: false // 开启千位分隔符
  }
}, {
  name: 'style-line',
  title: '折线配置',
  options: {
    lineWidth: 1,
    lineType: 'solid',
    lineSmooth: true
  }
}, {
  name: 'style-radar-label',
  title: '标签设置',
  options: {
    radarLabelSize: 12,
    radarLabelColor: '#333',
  }
}]
const modulesFiles = import.meta.globEager("./*.vue") // vite
setting.forEach(set => {
  window.$app.component(set.name, modulesFiles[`./${set.name}.vue`].default)
})
export default setting
