import {
  setStore,
  getStore,
  removeStore
} from '@/util/store'
import website from '@/config/website'
import {param} from '@/option/config'
const common = {

  state: {
    language: getStore({name: 'language'}) || 'zh',
    isCollapse: false,
    isFullScren: false,
    isMenu: false,
    isShade: false,
    screen: -1,
    isLock: getStore({name: 'isLock'}) || false,
    showTag: true,
    showDebug: false,
    showCollapse: true,
    showSearch: true,
    showLock: true,
    showFullScren: true,
    showTheme: true,
    showMenu: true,
    showColor: true,
    colorName: getStore({name: 'colorName'}) || '#409EFF',
    themeName: getStore({name: 'themeName'}) || 'theme-default',
    lockPasswd: getStore({name: 'lockPasswd'}) || '',
    website: website,
    commonParam: {
      date:{
        type: "MONTH",
        columnName: "THEDVALUE",
        startTime: param.startTime,
        endTime: param.endTime,
      },
      day:{
        type: "DAY",
        columnName: "THEDVALUE",
        today : param.today,
        last30 : param.lart30,
      }
    },
    isSearch:0,
    page:0,
  },
  mutations: {
    SET_LANGUAGE: (state, language) => {
      state.language = language
      setStore({
        name: 'language',
        content: state.language
      })
    },
    SET_SHADE: (state, active) => {
      state.isShade = active;
    },
    SET_IS_SEARCH: (state, num) => {
      if (num === -1){
        state.isSearch = 999;
      }else{
        state.isSearch = state.isSearch + num;
      }
    },
    SET_COLLAPSE: (state) => {
      state.isCollapse = !state.isCollapse;
    },
    SET_PARAM: (state,params) => {
      let data = Object.assign(state.commonParam,params);
      if (params.issearch == -1){
        params = {
          date:{
            type: "MONTH",
            columnName: "THEDVALUE",
            startTime: param.startTime,
            endTime: param.endTime,
          },
          day:{
            type: "DAY",
            columnName: "THEDVALUE",
            today : param.today,
            last30 : param.lart30,
          }
        }
        data = Object.assign({},params);
      }
      state.commonParam = data;
    },
    SET_PAGE: (state,page) => {
        var params = state.commonParam
        delete params.CATEGORYNAME
        delete params.AREA
        delete params.datetimeChange
        let paramm = {
          date:{
            type: "MONTH",
            columnName: "THEDVALUE",
            startTime: param.startTime,
            endTime: param.endTime,
          },
          day:{
            type: "DAY",
            columnName: "THEDVALUE",
            today : param.today,
            last30 : param.lart30,
          }
        }
        state.commonParam = Object.assign(state.commonParam,paramm);
        state.page = page;
        state.isSearch = 1;
    },
    SET_FULLSCREN: (state) => {
      state.isFullScren = !state.isFullScren;
    },
    SET_IS_MENU: (state, menu) => {
      state.isMenu = menu;
    },
    SET_LOCK: (state) => {
      state.isLock = true;
      setStore({
        name: 'isLock',
        content: state.isLock,
        type: 'session'
      })
    },
    SET_SCREEN: (state, screen) => {
      state.screen = screen;
    },
    SET_COLOR_NAME: (state, colorName) => {
      state.colorName = colorName;
      setStore({
        name: 'colorName',
        content: state.colorName,
      })
    },
    SET_THEME_NAME: (state, themeName) => {
      state.themeName = themeName;
      setStore({
        name: 'themeName',
        content: state.themeName,
      })
    },
    SET_LOCK_PASSWD: (state, lockPasswd) => {
      state.lockPasswd = lockPasswd;
      setStore({
        name: 'lockPasswd',
        content: state.lockPasswd,
        type: 'session'
      })
    },
    CLEAR_LOCK: (state) => {
      state.isLock = false;
      state.lockPasswd = '';
      removeStore({
        name: 'lockPasswd',
        type: 'session'
      });
      removeStore({
        name: 'isLock',
        type: 'session'
      });
    },
  }
}
export default common
